Imports System.IO
Imports System.Drawing.Printing

Public Class frmMain

    ' Counts for Breakfast, Lunch, Dinner, Snacks, and Total
    ' corresponding to the labels on the form ...
    Private mintCountAmt(0 To 4) As Integer
    Private mblnUserPrinted As Boolean

    ' Printing-related variables...
    Private mobjPrintFont As Font
    Private msngLinesPerPage As Single = 0
    Private msngVerticalPosition As Single = 0
    Private mintLineCount As Integer = 0
    Private mintPageCount As Integer = 0
    Private msngLeftMargin As Single
    Private msngTopMargin As Single

    Private Sub frmMain_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        Me.WindowState = FormWindowState.Minimized
        Me.ShowInTaskbar = False
    End Sub

    Private Sub frmMain_Shown(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Shown

        Dim strInputRec As String
        Dim strFoodDesc As String
        Dim strServSize As String
        Dim intFat As Integer
        Dim intCalories As Integer
        Dim intCarbos As Integer
        Dim intProtein As Integer
        Dim intCholesterol As Integer
        Dim intSelFoodCount As Integer

        Dim strFileName As String = My.Application.Info.DirectoryPath _
                          & "\FOODLIST.txt"
        Dim objFS As New FileStream(strFileName, FileMode.Open, FileAccess.Read)
        Dim objSR As New StreamReader(objFS)

        frmCntSel.ShowDialog()

        ' skip past the first two header records . . .
        objSR.ReadLine()
        objSR.ReadLine()

        ' Record Processing Loop . . .
        Do While objSR.Peek <> -1
            ' read the current record (line) into the variable strInputRec
            strInputRec = objSR.ReadLine()
            ' break up the record into separate variables
            strFoodDesc = strInputRec.Substring(0, 30)
            strServSize = strInputRec.Substring(30, 10)
            intFat = CInt(strInputRec.Substring(43, 5))
            intCalories = CInt(strInputRec.Substring(52, 5))
            intCarbos = CInt(strInputRec.Substring(64, 6))
            intProtein = CInt(strInputRec.Substring(75, 4))
            intCholesterol = CInt(strInputRec.Substring(83, 6))
            Select Case gstrFoodCountItem
                Case "Calories"
                    intSelFoodCount = intCalories
                Case "Fat"
                    intSelFoodCount = intFat
                Case "Carbohydrates"
                    intSelFoodCount = intCarbos
                Case "Protein"
                    intSelFoodCount = intProtein
                Case Else
                    intSelFoodCount = intCholesterol
            End Select
            lstAllFoods.Items.Add(New MyList(strFoodDesc.Trim & " (" & strServSize.Trim & ")", intSelFoodCount))
        Loop

        objSR.Close()

        lstAllFoods.SelectedIndex = 0

        lblTitle.Text = "Daily Menu Planner for " & Format(Now, "MMMM d, yyyy")

        lblCountDesc.Text = gstrFoodCountItem

        Me.WindowState = FormWindowState.Normal
        Me.ShowInTaskbar = True

    End Sub

    Private Sub frmMain_FormClosing(ByVal sender As Object, ByVal e As System.Windows.Forms.FormClosingEventArgs) Handles Me.FormClosing

        If Not mblnUserPrinted Then
            If MsgBox("Are you sure you want to quit without printing?", _
                      vbQuestion + vbYesNo, "Exit Program") = vbNo Then
                e.Cancel = True
            End If
        Else
            If MsgBox("Are you sure you want to quit?", _
                      vbQuestion + vbYesNo, "Exit Program") = vbNo Then
                e.Cancel = True
            End If
        End If

    End Sub

    Private Sub btnAdd_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) _
    Handles btnAdd0.Click, btnAdd1.Click, btnAdd2.Click, btnAdd3.Click

        Dim intIndex As Integer = CInt(Mid(sender.Name, 7))
        Dim lstMeal As ListBox
        Dim lblCountAmt As Label
        lstMeal = DirectCast(GetControlByName(Me, "lstMeal" & intIndex), ListBox)
        lblCountAmt = DirectCast(GetControlByName(Me, "lblCountAmt" & intIndex), Label)

        For intX As Integer = 0 To lstAllFoods.SelectedItems.Count - 1
            lstMeal.Items.Add _
                (New MyList(lstAllFoods.SelectedItems(intX).ToString, _
                            lstAllFoods.SelectedItems(intX).ItemData))
            mintCountAmt(intIndex) = mintCountAmt(intIndex) _
                                   + lstAllFoods.SelectedItems(intX).ItemData
            lblCountAmt.Text = CStr(mintCountAmt(intIndex))
            mintCountAmt(4) = mintCountAmt(4) _
                            + lstAllFoods.SelectedItems(intX).ItemData
            lblCountAmt4.Text = CStr(mintCountAmt(4))
        Next

    End Sub

    Private Sub btnRemove_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) _
    Handles btnRemove0.Click, btnRemove1.Click, btnRemove2.Click, btnRemove3.Click

        Dim intIndex As Integer = CInt(Mid(sender.Name, 10))
        Dim lstMeal As ListBox
        Dim lblCountAmt As Label
        lstMeal = DirectCast(GetControlByName(Me, "lstMeal" & intIndex), ListBox)
        lblCountAmt = DirectCast(GetControlByName(Me, "lblCountAmt" & intIndex), Label)

        For intX As Integer = (lstMeal.SelectedItems.Count - 1) To 0 Step -1
            mintCountAmt(intIndex) = mintCountAmt(intIndex) _
                                   - lstMeal.SelectedItems(intX).ItemData
            lblCountAmt.Text = CStr(mintCountAmt(intIndex))
            mintCountAmt(4) = mintCountAmt(4) _
                            - lstMeal.SelectedItems(intX).ItemData
            lblCountAmt4.Text = CStr(mintCountAmt(4))
            lstMeal.Items.Remove(lstMeal.SelectedItems(intX))
        Next

    End Sub

    Private Sub btnPrint_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnPrint.Click

        ' Declare an object for the PrintDocument class...
        Dim objPrintDocument As PrintDocument = New PrintDocument()

        ' Set the print font...
        mobjPrintFont = New Font("Courier New", 10)

        ' Add an event handler for the PrintPage event of the
        ' objPrintDocument object...
        AddHandler objPrintDocument.PrintPage, AddressOf objPrintDocument_PrintPage

        With PrintPreviewDialog1
            .FindForm().StartPosition = FormStartPosition.CenterScreen
            .Height = 600
            .Width = 800
            .PrintPreviewControl.Zoom = 0.75
            .Document = objPrintDocument
            .ShowDialog()
        End With

        mblnUserPrinted = True

    End Sub

    Private Sub btnExit_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnExit.Click
        Me.Close()
    End Sub

    Private Function GetControlByName(ByVal pobjParent As Control, _
                                      ByVal pstrCtlName As String) _
    As Control

        Dim objCtl As Control

        For Each objCtl In pobjParent.Controls
            If objCtl.Name = pstrCtlName Then
                Return (objCtl)
            End If
        Next

        ' if control is not found
        Return Nothing

    End Function

    Private Sub objPrintDocument_PrintPage(ByVal sender As Object, _
                                          ByVal e As System.Drawing.Printing.PrintPageEventArgs)

        Dim strLine As String
        Dim intLeadingSpaces As Integer
        Dim lstMeal As ListBox
        Dim lblCountAmt As Label

        ' set the left and top margins ...
        msngLeftMargin = e.MarginBounds.Left
        msngTopMargin = e.MarginBounds.Top

        ' set line count to zero
        mintLineCount = 0

        ' print headings
        intLeadingSpaces = (80 - lblTitle.Text.Length) \ 2
        strLine = lblTitle.Text.PadLeft(intLeadingSpaces + lblTitle.Text.Length)
        PrintReportLine(strLine, e)
        PrintReportLine(" ", e)
        strLine = " ".PadRight(14) & "Food" & " ".PadRight(41) & gstrFoodCountItem
        PrintReportLine(strLine, e)
        strLine = " ".PadRight(14) & "----" & " ".PadRight(41) & "-".PadRight(gstrFoodCountItem.Length, "-")
        PrintReportLine(strLine, e)

        For intX As Integer = 0 To 3
            PrintReportLine(" ", e)
            lstMeal = DirectCast(GetControlByName(Me, "lstMeal" & intX), ListBox)
            With lstMeal
                For intY As Integer = 0 To .Items.Count - 1
                    If intY = 0 Then
                        Select Case intX
                            Case 0 : strLine = "Breakfast"
                            Case 1 : strLine = "Lunch"
                            Case 2 : strLine = "Dinner"
                            Case 3 : strLine = "Snacks"
                        End Select
                    Else
                        strLine = ""
                    End If
                    strLine = (strLine.PadRight(14) & .Items(intY).ToString).PadRight(59) _
                            & Format(.Items(intY).ItemData, "#####0").PadLeft(6)
                    PrintReportLine(strLine, e)
                Next
            End With
            strLine = " ".PadRight(59) & "------"
            PrintReportLine(strLine, e)
            lblCountAmt = DirectCast(GetControlByName(Me, "lblCountAmt" & intX), Label)
            strLine = " ".PadRight(59) & Format(Val(lblCountAmt.Text), "######0").PadLeft(6)
            PrintReportLine(strLine, e)
        Next

        PrintReportLine(" ", e)
        strLine = " ".PadRight(59) & "------"
        PrintReportLine(strLine, e)
        strLine = " ".PadRight(44) & "TOTAL".PadLeft(15) & Format(Val(lblCountAmt4.Text), "######0").PadLeft(6)
        PrintReportLine(strLine, e)

    End Sub

    Private Sub PrintReportLine(ByVal pstrLine As String, _
                                ByVal e As System.Drawing.Printing.PrintPageEventArgs)

        ' Calculate the vertical position on the page...
        msngVerticalPosition = msngTopMargin _
                             + (mintLineCount * mobjPrintFont.GetHeight(e.Graphics))

        ' Pass the string to be printed to DrawString ...
        e.Graphics.DrawString(pstrLine, _
                              mobjPrintFont, _
                              Brushes.Black, _
                              msngLeftMargin, _
                              msngVerticalPosition, _
                              New StringFormat())

        ' Increment the line count...
        mintLineCount = mintLineCount + 1

    End Sub

End Class